Skip to main content
Jump to: navigation, search

Difference between revisions of "IRC FAQ"

(I just installed Eclipse on Linux, but it does not start. What is the problem?)
m (I just installed Eclipse on Linux, but it does not start. What is the problem?)
Line 204: Line 204:
 
===I just installed Eclipse on Linux, but it does not start. What is the problem?===
 
===I just installed Eclipse on Linux, but it does not start. What is the problem?===
  
Quite often, Eclipse will not work properly with non-Sun or non-IBM JVMs. Eclipse has a list of [http://www.eclipse.org/eclipse/development/readme_eclipse_3.2.1.html#TargetOperatingEnvironments reference platforms] that it is tested against which you should try to match against. These issues are usually related to [http://www.blackdown.org/ Blackdown] or [http://gcc.gnu.org/java/ GCJ]. Try installing one from  [http://java.sun.com/javase/downloads/index.jsp Sun], [http://www.ibm.com/developerworks/java/jdk/index.html IBM], or [http://www.bea.com/framework.jsp?CNT=index.htm&FP=/content/products/weblogic/jrockit/ BEA Jrockit] (eg., [http://java.sun.com/javase/downloads/index_jdk5.jsp Sun JDK 5.0],  [http://www.ibm.com/developerworks/java/jdk/linux/download.html IBM JDK 5.0], or [http://www.bea.com/framework.jsp?CNT=index.htm&FP=/content/products/weblogic/jrockit/ Jrockit 5.0]) and make sure that it is the one being used by starting Eclipse with an additional argument: <pre>eclipse -vm /full/path/to/java/bin/java</pre>
+
Quite often, Eclipse will not work properly with non-Sun or non-IBM JVMs. Eclipse has a list of [http://www.eclipse.org/eclipse/development/readme_eclipse_3.2.1.html#TargetOperatingEnvironments reference platforms] that it is tested against which you should try to match against. These issues are usually related to [http://www.blackdown.org/ Blackdown] or [http://gcc.gnu.org/java/ GCJ]. Try installing one from  [http://java.sun.com/javase/downloads/index.jsp Sun], [http://www.ibm.com/developerworks/java/jdk/index.html IBM], or [http://www.bea.com/framework.jsp?CNT=index.htm&FP=/content/products/weblogic/jrockit/ BEA Jrockit] (eg., [http://java.sun.com/javase/downloads/index_jdk5.jsp Sun JDK 5.0],  [http://www.ibm.com/developerworks/java/jdk/linux/download.html IBM JDK 5.0], or [http://www.bea.com/framework.jsp?CNT=index.htm&FP=/content/products/weblogic/jrockit/ JRockit 5.0]) and make sure that it is the one being used by starting Eclipse with an additional argument: <pre>eclipse -vm /full/path/to/java/bin/java</pre>
 
It is usually desirable to place this option in your '''[[Eclipse.ini | eclipse.ini]]''' file so you don't have to type it every time you start Eclipse.
 
It is usually desirable to place this option in your '''[[Eclipse.ini | eclipse.ini]]''' file so you don't have to type it every time you start Eclipse.
  

Revision as of 09:22, 10 February 2008

A collection of FAQs gathered in the Eclipse IRC channels.

Contents

General

What are #eclipse and #eclipse-dev about?

  • #eclipse is about development with Eclipse (for development of Eclipse, please see #eclipse-dev).
  • #eclipse-dev is about development of Eclipse (for development with Eclipse, please see #eclipse).

I am looking for help with developing with Eclipse. Should I ask on #eclipse or #eclipse-dev?

Probably #eclipse as long as your question relates to Eclipse usage or plug-in/RCP development. If the issue is purely a language issue unrelated to Eclipse, you should find a more appropriate channel that deals with that programming language. For example, freenode has a ##java channel for Java-related questions. You will need to be registered to nickserv to enter that channel though.

Are there other active channels about Eclipse?

  • #azureus about Azureus, an Eclipse-based BitTorrent client
  • #easyeclipse about EasyEclipse, an Eclipse distribution
  • #phpeclipse about PHPEclipse, an Eclipse-based IDE for PHP
  • #radrails about RadRails, an Eclipse plug-in for Ruby on Rails development
  • #rssowl about RSSOwl, a RSS reader built on Eclipse RCP
  • #subclipse about Subclipse, a Subversion plug-in
  • #udig about UDIG, an Eclipse-based GIS toolkit
  • #weblogic-eclipse about the Webglogic plug-in
  • #higgins about the Higgins Eclipse project

If you are using Linux, please consider visiting #fedora-java, #gentoo-java, and #ubuntu-java for distribution-specific questions.

Nobody is answering my question. What should I do?

First, be patient, the person that has an answer for you may be busy at the moment. Then please continue being patient as that person may be in another time zone. Be polite and gentle or you may be politely ignored. If nobody answers, it may just be that nobody knows the answer. You will have to do some research on your own. The Eclipse newsgroups are a good place, as well as the Eclipse Bugzilla. Remember that search engines are your best friends, and good luck! For those that have some idea of a possible solution, please do not hesitate to speak up!

Note also that not every project has experts or users who idle on IRC. So, here's a few other ways to get help:

  1. Read The FAQs: Eclipse FAQs, More FAQs
  2. Learn about the tools/projects you use from their websites or wiki pages
  3. Ask a question in the newsgroups
  4. Submit a question / discuss an issue / keep up to date in the mailing lists
  5. Browse source code in CVS to find an existing solution
  6. Read the online ISV help docs and APIs at help.eclipse.org
  7. Read articles, blogs, and other resources
  8. Watch videos of demos, walkthrus, and howtos
  9. Find, report, patch, triage, fix, or verify a bug or feature request
  10. Search with Eclipse or Google
  11. Seek legal advice about 3rd party code and IP

Installation, Startup and Runtime

I'm new, what should I read first?

Where can I get Eclipse?

What is Europa, and where can I get it?

Europa is the 2007 simultaneous release of 21 major Eclipse projects, including Eclipse 3.3. For a list of those projects, what they consist of, and how to easily get them, see: http://www.ibm.com/developerworks/opensource/library/os-eclipse-europa/.

What is Callisto, and where can I get it?

Callisto is the 2006 simultaneous release of 10 major Eclipse projects, including Eclipse 3.2.

Where can I get a list of all the Eclipse projects?

Well, for starters, there's:

Where can I get project XYZ?

You can search for downloads by project or by topic.

Or, start with that project's homepage (www.eclipse.org/xyz) and look for download or update links. For example, EMF: website, downloads, updates.

Download the zip and unpack it into your Eclipse install folder, or use a .link file [1] [2] to locate the project in another folder.

Or, if using Update Manager, add the Update URL here, then download and install the features and plugins that way:

Help > Software Updates > Find and Install... > 
  (*) Search for new features > Next > 
  New Remote Site > (add the new site) > Finish

Is there a Visual Editor (VE) for Eclipse 3.3 / Europa?

Yes, but it's under development. See VE Development Resources for an install guide and development roadmap.

Is there a PHP editor for Eclipse 3.3 / Europa?

Yes, there are two. Note that installing both concurrently can be a bad thing.

What is the Update Manager?

How do I start Eclipse?

The simplest way:

  • Double-click eclipse.exe or eclipse
  • Browse to the directory where you unpacked Eclipse, then run eclipse or ./eclipse

The usual way:

/path/to/eclipse/eclipse -data /path/to/workspace -vm /path/to/jvm/bin/java -vmargs -Xms256M -Xmx512M -XX:PermSize=64M -XX:MaxPermSize=128M 
- or -
c:\path\to\eclipse\eclipse.exe -data c:\path\to\workspace -vm c:\path\to\jvm\bin\java.exe -vmargs -Xms256M -Xmx512M -XX:PermSize=64M -XX:MaxPermSize=128M 

Using eclipse.ini:

Other ways:

Advanced ways:

Can I upgrade from Eclipse 3.2 (Callisto) to Eclipse 3.3 (Europa)?

Yes and no.

It depends on what plugins you use and if they have been updated to work with the new version of the platform. If you used projects that were part of Callisto and which are now part of Europa, the answer is most likely yes. Some plugins will work on Eclipse 3.0 - 3.3 without any problems. Others are version-specific because they exploit aspects of Eclipse that were added or changed along the way (such as internal APIs not intended to be extended).

To upgrade, download a copy of Eclipse or a Europa bundle (see above). Extract the downloaded archive into its own directory (do not extract it into an existing eclipse directory), start up the new Eclipse and point it at your old workspace. If you see a message like 'cannot restore perspective' then something that your old workspace relied on (eg., some view contributed by some plugin) is not working anymore, and you'll have to search for an updated version from that plugin's provider.

If you installed features/plugins outside your Eclipse folder, you can reuse them via Help > Software Updates > Manage Configuration > Add an Extension Location to point your new Eclipse at those old plugins. However, those plugin folders must have an .eclipseextension file in them for Eclipse to accept them, and as noted above, they may not work without being updated. Details on using .link files and Extension Locations here and here.

If you use JRE/JDK1.4 with Eclipse 3.2, you may need to update to JRE/JDK5.0 as some Europa components require JDK5.0 (eg., WTP, TPTP, EMF).

Can I use my Eclipse 3.2 workspace with Eclipse 3.3?

Yes and no.

Your project files are compatible, but some of your settings may not be. You might want to export your settings from the old workspace before attempting to open it with the new Eclipse, then import them into the new Eclipse. For example, Window > Preferences... > Java > Code Style > Formatter > Edit > Export.

You might also want to start a completely new workspace and use File > Import > Existing Projects into Workspace to migrate the old projects into the new workspace. They can be copied or simply linked (referenced) in their old workspace location.

How do I use a different workspace?

Three ways:

  1. In Eclipse, select File > Switch Workspace
  2. In Eclipse, select Window > Preferences... > General > Startup and Shutdown > [x] Prompt for workspace on startup, then restart Eclipse.
  3. Via commandline, run ./eclipse -data /path/to/new/workspace/folder

I'm having memory, heap, or permgen problems, what can I do?

What other commandline arguments are available?

How do I install Eclipse on Linux?

There are many schools of thought here, depending on your comfort level with Linux and the number of users on your system.

The simplest approach is to grab the latest bundle for your distro, using something like apt-get or yum. Please note that these bundles are often not the latest and greatest because they are released in concert with the distro release cycles, not that of Eclipse. For more on these repository packages, see Linux Distributions Project, or hang out in #eclipse-linux on freenode. If you're installing on ubuntu, here's a walkthrough.

If you want the latest, grab the Europa bundle or archive for your distribution. If you're on a 64-bit system, get the 64-bit version.

Save the archive into your home directory, ~ or /home/$USER/. Open a console or terminal, and type:

cd ~; tar xvzf eclipse*.tar.gz; 

To start up Eclipse, type:

cd ~/eclipse; ./eclipse -vm /path/to/bin/java

If you want to create a desktop or launcher shortcut, see this ubuntu walkthrough.

You can also install Eclipse in another location -- it's up to you, your distro's conventions, or your own preferences.

For a multi-user system, consider these three approaches or the official approach.

Once you have Eclipse installed, you can add other projects to it.

I just installed Eclipse on Linux, but it does not start. What is the problem?

Quite often, Eclipse will not work properly with non-Sun or non-IBM JVMs. Eclipse has a list of reference platforms that it is tested against which you should try to match against. These issues are usually related to Blackdown or GCJ. Try installing one from Sun, IBM, or BEA Jrockit (eg., Sun JDK 5.0, IBM JDK 5.0, or JRockit 5.0) and make sure that it is the one being used by starting Eclipse with an additional argument:
eclipse -vm /full/path/to/java/bin/java

It is usually desirable to place this option in your eclipse.ini file so you don't have to type it every time you start Eclipse.

The argument must point to the java or javaw executable, not some wrapper script like run-java-tool, as used on Gentoo.

First time downloading/installing Java for Linux? Read this or this.

I just installed Eclipse on Linux 64, but it does not start. What is the problem?

Make sure that you have downloaded the 64-bit version of Eclipse and have installed a Sun 64-bit JVM

How do I install a project with multiple dependencies?

For example, how do I install PDT?

There are numerous approaches here, depending on your need and starting point.

The simplest is to grab the All-In-One bundle from the project's download site, if one is provided for your platform, eg., PDT 1.0. Note too that if you're on 64-bit you need a 64-bit bundle (which may not exist).

But if:

  • there's no OS-compatible All-In-One available, or
  • you already have Eclipse installed, and
  • you want to add a project to an existing Eclipse, then ...


... you'll need to either:

  • download the individual required projects (most download pages have a "Requirements" section you can use for reference, but this can still be a pain), or
  • use the Update Manager to install the prereqs and the project you want, too.


Note that if you're installing from multiple update sites, you have to expand each one before you hit 'Select Required' for the wizard to be able to scan those sites and resolve all your dependencies. See bug 203473.

In the specific case for installing PDT 1.0, you only need the Europa Discovery site and the PDT Update site. However, you may find your specific mirror fails due to bug 203794. Solution until that bug is fixed: try another one.

Eclipse

Where are Eclipse's log files located?

  • <workspace>/.metadata/.log
You can view this workspace log as a view if you have PDE installed on your computer (which you would if you have downloaded the Eclipse SDK). You can open that view via Window -> Show View -> Other -> PDE Runtime -> Error Log.
  • <eclipse install>/configuration/<sometimestamp>.log
  • <eclipse install>/configuration/org.eclipse.update/install.log

I am working on a project and doing something or other does not work. Where should I start?

First, clean your projects using the menu item Project/Clean to trigger a rebuild.

Where are Eclipse preferences stored?

If you want to keep preferences from one version to the other, export them using File/Export/Preferences.

Preferences are stored in various places (this applies to Eclipse 3.1)

  • for each installation (but this may vary for multi-user installations), in files stored in <eclipse_home>/eclipse/configuration/.settings/ . There is typically one file per plugin, with a prefs extension. Note that very few plug-ins use installation-wide preferences.
  • for each workspace, in files stored in <workspace>/.metadata/.plugin/org.eclipse.core.runtime/.settings . There is typically one file per plugin, with a prefs extension.
  • for each project --for project-level settings -- in files stored in a .settings sub-directory of your project folder

Where are update site bookmarks stored?

It is within an XML file called <user_home>/.eclipse/org.eclipse.platform_3.1.2/configuration/org.eclipse.update/bookmarks.xml. Your Eclipse version may vary.

Where are my eclipse plug-ins folder?

The plug-ins folder is <eclipse_home>/plugins.

What's the key for ...?

The three most convenient key bindings are:

  • CTRL-SPACE: Content Assist
  • CTRL-3: Quick Access -- gives you quick access to nearly everything (Eclipse 3.3+)
  • CTRL-SHIFT-L: Show common keyboard shortcuts (Eclipse 3.2+)

Here are a few others:

  • CTRL-F6 / SHIFT-CTRL-F6: Cycle editor windows forwards / backwards
  • CTRL-F7 / SHIFT-CTRL-F7: Cycle views forward / backwards
  • CTRL-F8 / SHIFT-CTRL-F8: Cycle perspectives forward / backwards
  • CTRL-E: Show editor list / select editor window
  • F5: Refresh selected folder / file (useful if you edit files outside Eclipse)
  • SHIFT-ALT-X: Run As...
  • SHIFT-ALT-D: Debug As...
  • SHIFT-ALT-Q: Open View...

You can also remap key bindings via Window > Preferences... > General > Keys to suit your personal preference.

How do I add my own bindings?

See Platform Plug-in Developer Guide > Programmer's Guide > Advanced workbench concepts > Workbench key bindings.

Why can't I find the command I'm looking for?

  • To find commands which there are no keybindings:
Window > Preferences... > General > Keys
  [x] Include unbound commands
  • To find other commands, if the above didn't work:
Window > Preferences... > General > Keys > Advanced
  [ ] Filter action set contexts
  [ ] Filter internal contexts
  [ ] Filter uncategorized commands <-- this one is particularly useful

Why did Content Assist stop working?

First, select:

Window > Preferences... > General > Keys

Scroll to "Content Assist" and verify that CTRL-SPACE is still the hotkey. If it is, and Content Assist still doesn't work, several things can be the cause of this.

  • Non-English software or keyboards
  • Accessibility software such as screen readers
  • Background processes with key bindings

One known process that can interfere with CTRL-SPACE is Logitech's QuickCam10.exe. Upgrading to QuickCam 11 solves this problem. If you are not running this, try killing processes one by one until you get CTRL-SPACE back.

Why won't Content Assist work for my .xyz file type?

Make sure that you're opening the file with the correct editor. You may have several associated editors for a given file type, such as .php or .xml. Whatever was installed last is probably the default. If this is not your preferred editor, select:

Window > Preferences... > General > Editors > File Associations

and set a better default. Note that the last editor used will be used next time, so you might have to use Open With instead of Open.

If, for example, Content Assist works in your Java editor but not in your PHP editor, it could be a problem with your project's nature. See How do I manually assign a project Nature or BuildCommand?

How do I manually assign a project Nature or BuildCommand?

If your editor has a way to "add the xyz nature" to your project, such as via a context menu, use that. If not, here's another approach:

  • Create a new project of the type you need (such as PHP project or Java project or Plugin project)
  • Open the Navigator view
  • Open that new project's .project file.
  • Copy the <nature>s and <buildCommand>s from that .project into your actual project's .project file.

For a PHP project, this could be:

 <buildSpec>
   <buildCommand>
     <name>org.eclipse.php.core.PhpIncrementalProjectBuilder</name>
     <arguments></arguments>
   </buildCommand>
   <buildCommand>
     <name>org.eclipse.wst.validation.validationbuilder</name>
     <arguments></arguments>
   </buildCommand>
 </buildSpec>
 <natures>
   <nature>org.eclipse.php.core.PHPNature</nature>
 </natures>

For a Plug-in project:

 <buildSpec>
   <buildCommand>
     <name>org.eclipse.jdt.core.javabuilder</name>
     <arguments></arguments>
   </buildCommand>
   <buildCommand>
     <name>org.eclipse.pde.ManifestBuilder</name>
     <arguments></arguments>
   </buildCommand>
   <buildCommand>
     <name>org.eclipse.pde.SchemaBuilder</name>
     <arguments></arguments>
   </buildCommand>
 </buildSpec>
 <natures>
   <nature>org.eclipse.pde.PluginNature</nature>
   <nature>org.eclipse.jdt.core.javanature</nature>
 </natures>

Note also:

  • the order of the natures is important. See bug 204883.
  • some natures may conflict, such as PDT and phpeclipse. You might have to disable one nature to use the other.
  • restarting Eclipse should not be necessary, but if in doubt, try closing and reopening the project or restart it with Eclipse with eclipse -clean.

The javadoc for the standard Java classes does not show up as context help. What is the problem? Should I download the javadocs?

To get the standard java javadoc to display in hover and context help in the Eclipse java editor, you need to run a JDK . Eclipse retrieves the javadoc from the JDK java sources. The sources are bundled with a JDK but not with a JRE. The file containing the sources in the SUN JDK is src.zip.

What do you mean by 'run a JDK'?

The problem is that I've got unpacked java docs (and in archive too) at the proper location in the JDK dir and it is not displayed when working on java project...moreover javadoc specific to project is shown properly!

You need either to have the JDK set as the Java Runtime for your project or workspace, or have started Eclipse with that JDK. Make sure that the root dir of your JDK installation contains a file called src.zip.

But it still does *not* work! Help me!

Make sure that you have selected the JDK in your workspace or project preferences. For the workspace check under Windows -> Preferences -> Java -> Installed JREs. For a project, check the project's properties.

How do I override the environment variables that Ant uses during execution?

To override environment variables passed to Ant, open your launch configuration.

  • On the 'JRE' tab choose 'Separate JRE'. Select the required JRE from the list.
  • On the 'Environment' tab, click 'Select' button then pick the variables you want to override from the list and click OK. Click 'Edit' to change values.

How do I export a launch configuration?

Go into the 'Common' tab in your launch configuration and you will find a 'Browse' button to set the file that you want to export it as.

How do I find out which workspace I currently have open?

You can append the -showLocation to your Eclipse shortcut/script or eclipse.ini file. Now you will be able to see the path to your workspace in the Eclipse instance's window's title bar.

SWT

I cannot get the SWT widget ABC to work when I do XYZ. Could you help me?

Check the SWT Snippets section, there might be a code example that demonstrates what you are trying to do.here.

I cannot get Mozilla to run on Linux as an embedded browser?

Follow the instructions in the SWT FAQ.

I cannot get Firefox to run on Linux as an embedded browser?

Firefox is not supported as embedded browser on Linux for now. Take a look at bug #72487.

On some Linux distributions that dynamically link Firefox (like Ubuntu and Fedora), Firefox will work.

Version Control

I am having some trouble with CVS in eclipse -- is there a way I can get actual logs and see detailed error messages?

Open the console view and select CVS from the triangle drop-down in the console toolbar.

Where are the CVS repositories locations stored?

In <workspace>/.metadata/.plugin/org.eclipse.team.cvs.ui/repositoriesView.xml . Previously used commit comments are in commitCommentHistory.xml.

What plug-ins are there for Subversion integration?

You can try either Subclipse or Subversive.

I just installed Subversion on Mac/Linux, and then I installed Subclipse, but it does not work. What is the problem?

Verify that the version of Subclipse matches the version of Subversion that you have installed. Try uninstalling Subversion and configuring Subclipse's preferences to run JavaSVN. Take a look at the Subclipse FAQ. Ask on #subclipse for additional assistance.

I am trying to use svn+ssh:// with Subclipse, and it does not work?

Generally speaking, the JavaSVN adapter in the Team/SVN preferences will yield better results when using svn+ssh. See: Subclipse support for SVN protocols for detailed information.

Back to the top